(function ($) {
	"use strict";
	var WidgetAccordion = function ($scope, $) {
		if( $scope.find('.eca-accordion-wrapper').length ){
			var elements = $scope[0].querySelectorAll('.eca-accordion-wrapper');
			
			Array.prototype.forEach.call(elements, function(el, i){
			
				var settings = el.getAttribute('data-settings');
					settings = JSON.parse( settings );
					
					el.querySelectorAll('.eca-accordion-header').forEach((accordion, index) => {
						
						if(accordion.classList.contains('active-accordion')){							
							accordion.parentElement.style.height = accordion.nextElementSibling.clientHeight + accordion.clientHeight + 'px';
						}
						accordion.addEventListener(settings.type, (event) => {
							event.preventDefault();
							var currTitle = event.currentTarget,
								currContent = event.currentTarget.nextElementSibling,
								parentAcc = event.currentTarget.parentElement;
							
							if( ! parentAcc.classList.contains('active') ) {
								var elems = el.querySelectorAll('.eca-accordion-header.active-accordion');
								if(settings.multi!='yes'){
									[].forEach.call(elems, function(header) {
										header.parentElement.style.height = currTitle.clientHeight + 'px';
										header.parentElement.addEventListener('transitionend', function () {
											header.parentElement.classList.remove('active');
											header.classList.remove('active-accordion');
											header.nextElementSibling.classList.remove('active-accordion');
										}, {
											once: true
										});
									  });
								}
								parentAcc.classList.add('active');
								currTitle.classList.add('active-accordion');
								currContent.classList.add('active-accordion');
								
								var height = currContent.clientHeight + currTitle.clientHeight + 'px';
								parentAcc.style.height = currTitle.clientHeight + 'px';
								
								setTimeout(function () {
									parentAcc.style.height = height;
								}, 0);
							}else {
								parentAcc.style.height = currTitle.clientHeight + 'px';
								parentAcc.addEventListener('transitionend', function () {
									parentAcc.classList.remove('active');
									currTitle.classList.remove('active-accordion');
									currContent.classList.remove('active-accordion');
								}, {
									once: true
								});
							}
						})
					});
			});
		}
	};
	$(window).on('elementor/frontend/init', function () {
		elementorFrontend.hooks.addAction('frontend/element_ready/ecafe-accordion.default', WidgetAccordion);
	});
})(jQuery);