(function ($) {
	"use strict";
	var WidgetTabs = function ($scope, $) {
		if( $scope.find('.eca-tabs-wrapper').length ){
			var elements = $scope[0].querySelectorAll('.eca-tabs-wrapper');
			
			Array.prototype.forEach.call(elements, function(el, i){
			
				var settings = el.getAttribute('data-settings');
					settings = JSON.parse( settings );
				
				el.querySelectorAll('.eca-tabs-title-wrap .eca-tab-title').forEach((tab, index) => {
					if( 'click' == settings.type ) {
						tab.addEventListener('click', (event) => {
							event.preventDefault();
							tabsClickHover(event, el);
						});
					}else if( 'hover' == settings.type ){
						tab.addEventListener('mouseover', (event) => {
							event.preventDefault();
							tabsClickHover(event, el);
						});
					}
				});
				var wd = window.innerWidth;
				if(settings.accordion===true && wd<=767){
					$(el).find('.eca-tab-accordion-title').each(function(i) {
						if( $(this).hasClass('tab-active') ) {
							$(this).next('.eca-tab-content').addClass('tab-active').css('display', 'block').slideDown(300);
						}
					});
					$(el).find('.eca-tab-accordion-title').on('click', function() {
						if( $(this).hasClass('tab-active') ) {
							$(this).removeClass('tab-active');
							$(this).next('.eca-tab-content').removeClass('tab-active').slideUp(300);
						}else {
							$(el).find('.eca-tab-accordion-title').removeClass('tab-active');
							$(el).find('.eca-tab-accordion-title').next('.eca-tab-content').removeClass('tab-active').slideUp(300);
					
							$(this).toggleClass('tab-active');
							$(this).next('.eca-tab-content').slideToggle(300, function() {
								$(this).toggleClass('tab-active');
							});
						}
					});
				}
			});
		}
	};
	function tabsClickHover(event, el){
		var curr_title = event.currentTarget,
			dataList = event.currentTarget.dataset;
		if( ! curr_title.classList.contains('tab-active') ) {
			var elems = el.querySelectorAll('.eca-tabs-title-wrap .eca-tab-title');
			[].forEach.call(elems, function(header) {
				var titleData = header.dataset;
				if(header.classList.contains('tab-active')){
					header.classList.remove('tab-active');
				}else if(dataList.tab === titleData.tab){
					header.classList.add('tab-active');
				}
			})
			var elemsContent = el.querySelectorAll('.eca-tabs-content-wrap .eca-tab-content');
			[].forEach.call(elemsContent, function(content) {
				var contentData = content.dataset;
				if(content.classList.contains('tab-active')){
					content.classList.remove('tab-active');
				}else if(dataList.tab === contentData.tab){
					content.classList.add('tab-active');
				}
			})
		}
	}
	$(window).on('elementor/frontend/init', function () {
		elementorFrontend.hooks.addAction('frontend/element_ready/ecafe-tabs.default', WidgetTabs);
	});
})(jQuery);