<?php
namespace EcafeAddons\Widgets;

use Elementor\Widget_Base;
use Elementor\Controls_Manager;
use Elementor\Utils;
use Elementor\Scheme_Color;
use Elementor\Group_Control_Typography;
use Elementor\Scheme_Typography;
use Elementor\Group_Control_Border;
use Elementor\Group_Control_Background;
use Elementor\Group_Control_Box_Shadow;
use Elementor\Group_Control_Text_Shadow;
use Elementor\Group_Control_Css_Filter;
use Elementor\Group_Control_Image_Size;

use EcafeAddons\EcafeElementLoad;

// Prevent direct access to files
if (!defined('ABSPATH')) {
    exit;
}

class Ecafe_Image_Hover_Effect extends Widget_Base {
	
	public function get_name() {
		return 'ecafe-image-hover-effect';
	}

	public function get_title() {
		return esc_html__('Image Hover Effect', 'essential-classy-addons-for-elementor');
	}

	public function get_icon() {
		 return 'ecafe-ele-back-icon ecafe-imagehovereffect-icon';
	}
	public function get_categories() {
        return array('essential');
    }
	public function get_keywords() {
		return ['image hover','advanced image hover','image effect','infobox','infobanner','button','box','skin','tags','title','heading','servicebox','image','layout','creative','html','animation','builder','custom','loop','social'];
	}
	
	public function get_style_depends() {
		return [ 'font-awesome-5-all','ecafe-image-hover-effect' ];
    }
	
	protected function register_controls() {
		$this->start_controls_section(
			'contentSection',
			[
				'label' => esc_html__( 'Advanced Image Hover Effect', 'essential-classy-addons-for-elementor' ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);	
		$this->add_control(
			'layout',
			[
				'label' => esc_html__( 'Layout', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'layout-1',
				'options' => [
					'layout-1'  => esc_html__( 'Layout 1', 'essential-classy-addons-for-elementor' ),
					'layout-2' => esc_html__( 'Layout 2', 'essential-classy-addons-for-elementor' ),
					'layout-3' => esc_html__( 'Layout 3', 'essential-classy-addons-for-elementor' ),
					'layout-4' => esc_html__( 'Layout 4', 'essential-classy-addons-for-elementor' ),
					'layout-5' => esc_html__( 'Layout 5', 'essential-classy-addons-for-elementor' ),
					'layout-6' => esc_html__( 'Layout 6', 'essential-classy-addons-for-elementor' ),
					'layout-7' => esc_html__( 'Layout 7', 'essential-classy-addons-for-elementor' ),
					'layout-8' => esc_html__( 'Layout 8', 'essential-classy-addons-for-elementor' ),
					'layout-9' => esc_html__( 'Layout 9', 'essential-classy-addons-for-elementor' ),
					'layout-10' => esc_html__( 'Layout 10', 'essential-classy-addons-for-elementor' ),
					'layout-11' => esc_html__( 'Layout 11', 'essential-classy-addons-for-elementor' ),
					'layout-12' => esc_html__( 'Layout 12', 'essential-classy-addons-for-elementor' ),
					'layout-13' => esc_html__( 'Layout 13', 'essential-classy-addons-for-elementor' ),
					'layout-14' => esc_html__( 'Layout 14', 'essential-classy-addons-for-elementor' ),
					'layout-15' => esc_html__( 'Layout 15', 'essential-classy-addons-for-elementor' ),
					'layout-16' => esc_html__( 'Layout 16', 'essential-classy-addons-for-elementor' ),
					'layout-17' => esc_html__( 'Layout 17', 'essential-classy-addons-for-elementor' ),
					'layout-18' => esc_html__( 'Layout 18', 'essential-classy-addons-for-elementor' ),
					'layout-19' => esc_html__( 'Layout 19', 'essential-classy-addons-for-elementor' ),
					'layout-20' => esc_html__( 'Layout 20', 'essential-classy-addons-for-elementor' ),
					'layout-21' => esc_html__( 'Layout 21', 'essential-classy-addons-for-elementor' ),
					'layout-22' => esc_html__( 'Layout 22', 'essential-classy-addons-for-elementor' ),
					'layout-23' => esc_html__( 'Layout 23', 'essential-classy-addons-for-elementor' ),
					'layout-24' => esc_html__( 'Layout 24', 'essential-classy-addons-for-elementor' ),
					'layout-25' => esc_html__( 'Layout 25', 'essential-classy-addons-for-elementor' ),
					'layout-26' => esc_html__( 'Layout 26', 'essential-classy-addons-for-elementor' ),
				],
			]
		);
		$this->add_control(
			'aiheeImage',
			[
				'label' => esc_html__( 'Image', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::MEDIA,
				'default' => [
					'url' => \Elementor\Utils::get_placeholder_image_src(),
				],
				'separator'	=> 'before',
			]
		);
		$this->add_group_control(
			Group_Control_Image_Size::get_type(),
			[
				'name' => 'thumbnail',
				'default' => 'full',
				'separator' => 'none',
			]
		);
		$this->add_control(
			'headingTitle',
			[
				'label' => esc_html__( 'Title', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,
				'dynamic' => ['active' => true,],
				'default' => esc_html__( 'Image Hover Effect', 'essential-classy-addons-for-elementor' ),
				'placeholder' => esc_html__( 'Enter Title', 'essential-classy-addons-for-elementor' ),
				'separator' => 'before',
			]
		);		
		$this->add_control(
			'headingTitleTag',
			[
				'label' => esc_html__( 'Title Tag', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'h1',
				'options' => [
					'h1'  => esc_html__( 'H1', 'essential-classy-addons-for-elementor' ),
					'h2' => esc_html__( 'H2', 'essential-classy-addons-for-elementor' ),
					'h3' => esc_html__( 'H3', 'essential-classy-addons-for-elementor' ),
					'h4' => esc_html__( 'H4', 'essential-classy-addons-for-elementor' ),
					'h5' => esc_html__( 'H5', 'essential-classy-addons-for-elementor' ),
					'h6' => esc_html__( 'H6', 'essential-classy-addons-for-elementor' ),
				],
			]
		);
		$this->add_control(
			'descriptionText',
			[
				'label' => esc_html__( 'Description', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::WYSIWYG,
				'default' => esc_html__( 'I am text block.', 'essential-classy-addons-for-elementor' ),
				'dynamic' => ['active' => true,],
			]
		);
		$this->add_control(
			'buttonHeading',
			[
				'label' => esc_html__( 'Button', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::HEADING,
				'separator' => 'before',
			]
		);
		$this->add_control(
			'buttonType',
			[
				'label' => esc_html__( 'Type', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'icon',
				'options' => [
					'icon'  => esc_html__( 'Icon', 'essential-classy-addons-for-elementor' ),
					'text' => esc_html__( 'Text', 'essential-classy-addons-for-elementor' ),
				],
			]
		);
		$this->add_control(
			'buttonIcon1',
			[
				'label' => esc_html__( 'First Icon', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::ICONS,
				'default' => [
					'value' => 'fab fa-facebook-square',
					'library' => 'solid',
				],
				'condition' => [
					'buttonType' => 'icon',
				],	
			]
		);
		$this->add_control(
			'buttonText1',
			[
				'label' => esc_html__( 'First Text', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,
				'dynamic' => ['active' => true,],
				'default' => esc_html__( 'A', 'essential-classy-addons-for-elementor' ),
				'placeholder' => esc_html__( 'Enter First Text', 'essential-classy-addons-for-elementor' ),
				'condition' => [
					'buttonType' => 'text',
				],
			]
		);
		$this->add_control(
			'buttonUrl1',
			[
				'label' => esc_html__( 'First Button URL', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::URL,				
				'placeholder' => esc_html__( 'https://www.demo-link.com', 'essential-classy-addons-for-elementor' ),
				'dynamic' => ['active' => true,],
				'default' => ['url' => '#',],
				'show_external' => true,
			]
		);
		$this->add_control(
			'buttonIcon2',
			[
				'label' => esc_html__( 'Second Icon', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::ICONS,
				'default' => [
					'value' => 'fab fa-twitter-square',
					'library' => 'solid',
				],
				'separator' => 'before',
				'condition' => [
					'buttonType' => 'icon',
				],	
			]
		);
		$this->add_control(
			'buttonText2',
			[
				'label' => esc_html__( 'Second Text', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,
				'dynamic' => ['active' => true,],
				'default' => esc_html__( 'B', 'essential-classy-addons-for-elementor' ),
				'placeholder' => esc_html__( 'Enter Second Text', 'essential-classy-addons-for-elementor' ),
				'separator' => 'before',
				'condition' => [
					'buttonType' => 'text',
				],
			]
		);
		$this->add_control(
			'buttonUrl2',
			[
				'label' => esc_html__( 'Second Button URL', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::URL,				
				'placeholder' => esc_html__( 'https://www.demo-link.com', 'essential-classy-addons-for-elementor' ),
				'dynamic' => ['active' => true,],
				'default' => ['url' => '#',],
				'show_external' => true,
			]
		);
		$this->add_control(
			'buttonIcon3',
			[
				'label' => esc_html__( 'Third Icon', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::ICONS,
				'default' => [
					'value' => 'fab fa-linkedin',
					'library' => 'solid',
				],
				'separator' => 'before',
				'condition' => [
					'buttonType' => 'icon',
				],	
			]
		);
		$this->add_control(
			'buttonText3',
			[
				'label' => esc_html__( 'Third Text', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,
				'dynamic' => ['active' => true,],
				'default' => esc_html__( 'C', 'essential-classy-addons-for-elementor' ),
				'placeholder' => esc_html__( 'Enter Third Text', 'essential-classy-addons-for-elementor' ),
				'separator' => 'before',
				'condition' => [
					'buttonType' => 'text',
				],
			]
		);
		$this->add_control(
			'buttonUrl3',
			[
				'label' => esc_html__( 'Third Button URL', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::URL,				
				'placeholder' => esc_html__( 'https://www.demo-link.com', 'essential-classy-addons-for-elementor' ),
				'dynamic' => ['active' => true,],
				'default' => ['url' => '#',],
				'show_external' => true,
			]
		);	
		$this->end_controls_section();
		
		/*style start*/
		/*title style start*/
		$this->start_controls_section(
            'titleStyling',
            [
                'label' => esc_html__('Title', 'essential-classy-addons-for-elementor'),
                'tab' => Controls_Manager::TAB_STYLE,				
            ]
        );
		$this->add_responsive_control(
			'titlePadding',
			[
				'label' => esc_html__( 'Padding', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', 'em', '%' ],			
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheheading-title' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_responsive_control(
			'titleMargin',
			[
				'label' => esc_html__( 'Margin', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', 'em', '%' ],			
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheheading-title' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Typography::get_type(),
			[
				'name' => 'titleTypography',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheheading-title',
			]
		);
		$this->start_controls_tabs( 'tabsTitleStyle' );
		$this->start_controls_tab(
			'titleNormal',
			[
				'label' => esc_html__( 'Normal', 'essential-classy-addons-for-elementor' ),
			]
		);
		$this->add_control(
			'titleNColor',
			[
				'label' => esc_html__( 'Color', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheheading-title' => 'color: {{VALUE}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Background::get_type(),
			[
				'name'      => 'titleNBg',
				'types'     => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheheading-title',
			]
		);
		$this->add_group_control(
			Group_Control_Border::get_type(),
			[
				'name' => 'titleNBorder',
				'label' => esc_html__( 'Border', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheheading-title',
			]
		);
		$this->add_responsive_control(
			'titleNBr',
			[
				'label'      => esc_html__( 'Border Radius', 'essential-classy-addons-for-elementor' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%' ],
				'selectors'  => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheheading-title' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			[
				'name'     => 'titleNShadow',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheheading-title',
			]
		);
		$this->add_group_control(
			Group_Control_Text_Shadow::get_type(),
			[
				'name' => 'titleNTextShadow',
				'label' => esc_html__( 'Text Shadow', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheheading-title',
			]
		);
		$this->add_control(
			'titleNTransition',
			[
				'label' => esc_html__( 'Transition css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'all 0.3s linear', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheheading-title' => 'transition: {{VALUE}};'
				],
				'separator' => 'before',
			]
		);
		$this->add_control(
			'titleNTransform',
			[
				'label' => esc_html__( 'Transform css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'rotate(25deg) scale(1.2)', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheheading-title' => 'transform: {{VALUE}};-ms-transform: {{VALUE}};-moz-transform: {{VALUE}};-webkit-transform: {{VALUE}};'
				],
			]
		);
		$this->add_group_control(
			Group_Control_Css_Filter::get_type(),
			[
				'name' => 'titleNFilters',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheheading-title',
			]
		);
		$this->end_controls_tab();
		$this->start_controls_tab(
			'titleHover',
			[
				'label' => esc_html__( 'Hover', 'essential-classy-addons-for-elementor' ),
			]
		);
		$this->add_control(
			'titleHColor',
			[
				'label' => esc_html__( 'Color', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheheading-title' => 'color: {{VALUE}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Background::get_type(),
			[
				'name'      => 'titleHBg',
				'types'     => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheheading-title',
			]
		);
		$this->add_group_control(
			Group_Control_Border::get_type(),
			[
				'name' => 'titleHBorder',
				'label' => esc_html__( 'Border', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheheading-title',
			]
		);
		$this->add_responsive_control(
			'titleHBr',
			[
				'label'      => esc_html__( 'Border Radius', 'essential-classy-addons-for-elementor' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%' ],
				'selectors'  => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheheading-title' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			[
				'name'     => 'titleHShadow',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheheading-title',
			]
		);
		$this->add_group_control(
			Group_Control_Text_Shadow::get_type(),
			[
				'name' => 'titleHTextShadow',
				'label' => esc_html__( 'Text Shadow', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheheading-title',
			]
		);
		$this->add_control(
			'titleHTransition',
			[
				'label' => esc_html__( 'Transition css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'all 0.3s linear', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheheading-title' => 'transition: {{VALUE}};'
				],
				'separator' => 'before',
			]
		);
		$this->add_control(
			'titleHTransform',
			[
				'label' => esc_html__( 'Transform css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'rotate(25deg) scale(1.2)', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheheading-title' => 'transform: {{VALUE}};-ms-transform: {{VALUE}};-moz-transform: {{VALUE}};-webkit-transform: {{VALUE}};'
				],
			]
		);
		$this->add_group_control(
			Group_Control_Css_Filter::get_type(),
			[
				'name' => 'titleHFilters',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheheading-title',
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		$this->end_controls_section();
		/*title style end*/
		
		/*description style start*/
		$this->start_controls_section(
            'descriptionStyling',
            [
                'label' => esc_html__('Description', 'essential-classy-addons-for-elementor'),
                'tab' => Controls_Manager::TAB_STYLE,				
            ]
        );
		$this->add_responsive_control(
			'descriptionPadding',
			[
				'label' => esc_html__( 'Padding', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', 'em', '%' ],			
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-ihedescription' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_responsive_control(
			'descriptionMargin',
			[
				'label' => esc_html__( 'Margin', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', 'em', '%' ],			
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-ihedescription' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Typography::get_type(),
			[
				'name' => 'descriptionTypography',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-ihedescription,{{WRAPPER}} .eca-ihemain-wrapper .eca-ihedescription p',
			]
		);
		$this->start_controls_tabs( 'tabsDescriptionStyle' );
		$this->start_controls_tab(
			'descriptionNormal',
			[
				'label' => esc_html__( 'Normal', 'essential-classy-addons-for-elementor' ),
			]
		);
		$this->add_control(
			'descriptionNColor',
			[
				'label' => esc_html__( 'Color', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-ihedescription' => 'color: {{VALUE}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Background::get_type(),
			[
				'name'      => 'descriptionNBg',
				'types'     => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-ihedescription',
			]
		);
		$this->add_group_control(
			Group_Control_Border::get_type(),
			[
				'name' => 'descriptionNBorder',
				'label' => esc_html__( 'Border', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-ihedescription',
			]
		);
		$this->add_responsive_control(
			'descriptionNBr',
			[
				'label'      => esc_html__( 'Border Radius', 'essential-classy-addons-for-elementor' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%' ],
				'selectors'  => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-ihedescription' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			[
				'name'     => 'descriptionNShadow',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-ihedescription',
			]
		);
		$this->add_group_control(
			Group_Control_Text_Shadow::get_type(),
			[
				'name' => 'descriptionNTextShadow',
				'label' => esc_html__( 'Text Shadow', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-ihedescription',
			]
		);
		$this->add_control(
			'descriptionNTransition',
			[
				'label' => esc_html__( 'Transition css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'all 0.3s linear', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-ihedescription' => 'transition: {{VALUE}};'
				],
				'separator' => 'before',
			]
		);
		$this->add_control(
			'descriptionNTransform',
			[
				'label' => esc_html__( 'Transform css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'rotate(25deg) scale(1.2)', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-ihedescription' => 'transform: {{VALUE}};-ms-transform: {{VALUE}};-moz-transform: {{VALUE}};-webkit-transform: {{VALUE}};'
				],
			]
		);
		$this->add_group_control(
			Group_Control_Css_Filter::get_type(),
			[
				'name' => 'descriptionNFilters',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-ihedescription',
			]
		);
		$this->end_controls_tab();
		$this->start_controls_tab(
			'descriptionHover',
			[
				'label' => esc_html__( 'Hover', 'essential-classy-addons-for-elementor' ),
			]
		);
		$this->add_control(
			'descriptionHColor',
			[
				'label' => esc_html__( 'Color', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-ihedescription' => 'color: {{VALUE}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Background::get_type(),
			[
				'name'      => 'descriptionHBg',
				'types'     => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-ihedescription',
			]
		);
		$this->add_group_control(
			Group_Control_Border::get_type(),
			[
				'name' => 'descriptionHBorder',
				'label' => esc_html__( 'Border', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-ihedescription',
			]
		);
		$this->add_responsive_control(
			'descriptionHBr',
			[
				'label'      => esc_html__( 'Border Radius', 'essential-classy-addons-for-elementor' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%' ],
				'selectors'  => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-ihedescription' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			[
				'name'     => 'descriptionHShadow',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-ihedescription',
			]
		);
		$this->add_group_control(
			Group_Control_Text_Shadow::get_type(),
			[
				'name' => 'descriptionHTextShadow',
				'label' => esc_html__( 'Text Shadow', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-ihedescription',
			]
		);
		$this->add_control(
			'descriptionHTransition',
			[
				'label' => esc_html__( 'Transition css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'all 0.3s linear', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-ihedescription' => 'transition: {{VALUE}};'
				],
				'separator' => 'before',
			]
		);
		$this->add_control(
			'descriptionHTransform',
			[
				'label' => esc_html__( 'Transform css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'rotate(25deg) scale(1.2)', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-ihedescription' => 'transform: {{VALUE}};-ms-transform: {{VALUE}};-moz-transform: {{VALUE}};-webkit-transform: {{VALUE}};'
				],
			]
		);
		$this->add_group_control(
			Group_Control_Css_Filter::get_type(),
			[
				'name' => 'descriptionHFilters',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-ihedescription',
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		$this->end_controls_section();
		/*description style end*/
		
		/*button icon style start*/
		$this->start_controls_section(
            'buttonIcontextStyling',
            [
                'label' => esc_html__('Button Icon/Text', 'essential-classy-addons-for-elementor'),
                'tab' => Controls_Manager::TAB_STYLE,
            ]
        );
		$this->add_responsive_control(
			'buttonIconpadding',
			[
				'label' => esc_html__( 'Padding', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', 'em', '%' ],			
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_responsive_control(
			'buttonIconmargin',
			[
				'label' => esc_html__( 'Margin', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', 'em', '%' ],			
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_control(
			'buttonIconsize',
			[
				'label' => esc_html__( 'Size', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::SLIDER,
				'size_units' => ['px','%'],
				'range' => [
					'px' => [
						'max' => 1,
						'min' => 100,
						'step' => 1,
					],
					'%' => [
						'min' => 1,
						'max' => 100,
						'step' => 1,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon i' => 'font-size: {{SIZE}}{{UNIT}};',
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon svg' => 'width: {{SIZE}}{{UNIT}};height: {{SIZE}}{{UNIT}};',
				],				
				'condition' => [
					'buttonType' => 'icon',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Typography::get_type(),
			[
				'name' => 'buttonTexttypography',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon',
				'condition' => [
					'buttonType' => 'text',	
				],
			]
		);		
		$this->start_controls_tabs( 'tabs_buttonIconstyle' );
		$this->start_controls_tab(
			'buttonIconnormal',
			[
				'label' => esc_html__( 'Normal', 'essential-classy-addons-for-elementor' ),
			]
		);
		$this->add_control(
			'buttonIconNColor',
			[
				'label' => esc_html__( 'Color', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon i,{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon' => 'color: {{VALUE}};',
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon svg' => 'fill : {{VALUE}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Background::get_type(),
			[
				'name'      => 'buttonIconNBg',
				'types'     => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon',
			]
		);
		$this->add_group_control(
			Group_Control_Border::get_type(),
			[
				'name' => 'buttonIconNBorder',
				'label' => esc_html__( 'Border', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon',
			]
		);
		$this->add_responsive_control(
			'buttonIconNBr',
			[
				'label'      => esc_html__( 'Border Radius', 'essential-classy-addons-for-elementor' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%' ],
				'selectors'  => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			[
				'name'     => 'buttonIconNShadow',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon',
			]
		);		
		$this->end_controls_tab();
		$this->start_controls_tab(
			'buttonIcoNHover',
			[
				'label' => esc_html__( 'Hover', 'essential-classy-addons-for-elementor' ),
			]
		);
		$this->add_control(
			'buttonIconHColor',
			[
				'label' => esc_html__( 'Color', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon:hover i,{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon:hover' => 'color: {{VALUE}};',
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon:hover svg' => 'fill: {{VALUE}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Background::get_type(),
			[
				'name'      => 'buttonIconHBg',
				'types'     => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon:hover',
			]
		);
		$this->add_group_control(
			Group_Control_Border::get_type(),
			[
				'name' => 'buttonIconHBorder',
				'label' => esc_html__( 'Border', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon:hover',
			]
		);
		$this->add_responsive_control(
			'buttonIconHBr',
			[
				'label'      => esc_html__( 'Border Radius', 'essential-classy-addons-for-elementor' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%' ],
				'selectors'  => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon:hover' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			[
				'name'     => 'buttonIconHShadow',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheicons .eca-iheicon:hover',
			]
		);		
		$this->end_controls_tab();
		$this->end_controls_tabs();
		$this->end_controls_section();
		/*button icon/text style end*/
		
		/*image/background style start*/
		$this->start_controls_section(
            'imageBackgroundStyling',
            [
                'label' => esc_html__('Image', 'essential-classy-addons-for-elementor'),
                'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'layout' => ['layout-3','layout-4','layout-5','layout-6','layout-7','layout-8','layout-9','layout-10','layout-11'],
				],
            ]
        );
		$this->add_responsive_control(
            'ibMaxWidth',
            [
                'type' => Controls_Manager::SLIDER,
				'label' => esc_html__('Max Width', 'essential-classy-addons-for-elementor'),
				'size_units' => [ 'px' ],				
				'range' => [
					'px' => [
						'min'	=> 1,
						'max'	=> 500,
						'step' => 1,
					],
				],
				'render_type' => 'ui',				
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheimage' => 'max-width: {{SIZE}}{{unit}};',
				],
            ]
        );
		$this->start_controls_tabs( 'tabsIbStyle' );
		$this->start_controls_tab(
			'ibNormal',
			[
				'label' => esc_html__( 'Normal', 'essential-classy-addons-for-elementor' ),
			]
		);
		$this->add_group_control(
			Group_Control_Background::get_type(),
			[
				'name'      => 'ibNBg',
				'types'     => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheimage',
			]
		);
		$this->add_group_control(
			Group_Control_Border::get_type(),
			[
				'name' => 'ibNBorder',
				'label' => esc_html__( 'Border', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheimage',
			]
		);
		$this->add_responsive_control(
			'ibNBr',
			[
				'label'      => esc_html__( 'Border Radius', 'essential-classy-addons-for-elementor' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%' ],
				'selectors'  => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheimage' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			[
				'name'     => 'ibNShadow',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheimage',
			]
		);
		$this->add_control(
			'ibNTransition',
			[
				'label' => esc_html__( 'Transition css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'all 0.3s linear', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheimage' => 'ms-transition: {{VALUE}};'
				],
				'separator' => 'before',
			]
		);
		$this->add_control(
			'ibNTransform',
			[
				'label' => esc_html__( 'Transform css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'rotate(25deg) scale(1.2)', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-iheimage' => 'transform: {{VALUE}};-ms-transform: {{VALUE}};-moz-transform: {{VALUE}};-webkit-transform: {{VALUE}};'
				],
			]
		);
		$this->add_group_control(
			Group_Control_Css_Filter::get_type(),
			[
				'name' => 'ibNFilters',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper .eca-iheimage',
			]
		);
		$this->end_controls_tab();
		$this->start_controls_tab(
			'ibHover',
			[
				'label' => esc_html__( 'Hover', 'essential-classy-addons-for-elementor' ),
			]
		);
		$this->add_group_control(
			Group_Control_Background::get_type(),
			[
				'name'      => 'ibHBg',
				'types'     => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheimage',
			]
		);
		$this->add_group_control(
			Group_Control_Border::get_type(),
			[
				'name' => 'ibHBorder',
				'label' => esc_html__( 'Border', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheimage',
			]
		);
		$this->add_responsive_control(
			'ibHBr',
			[
				'label'      => esc_html__( 'Border Radius', 'essential-classy-addons-for-elementor' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%' ],
				'selectors'  => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheimage' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			[
				'name'     => 'ibHShadow',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheimage',
			]
		);
		$this->add_control(
			'ibHTransition',
			[
				'label' => esc_html__( 'Transition css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'all 0.3s linear', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheimage' => 'transition: {{VALUE}};'
				],
				'separator' => 'before',
			]
		);
		$this->add_control(
			'ibHTransform',
			[
				'label' => esc_html__( 'Transform css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'rotate(25deg) scale(1.2)', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheimage' => 'transform: {{VALUE}};-ms-transform: {{VALUE}};-moz-transform: {{VALUE}};-webkit-transform: {{VALUE}};'
				],
			]
		);
		$this->add_group_control(
			Group_Control_Css_Filter::get_type(),
			[
				'name' => 'ibHFilters',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover .eca-iheimage',
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		$this->end_controls_section();
		/*image style end*/
		
		/*background style start*/
		$this->start_controls_section(
            'background21_26Styling',
            [
                'label' => esc_html__('Background', 'essential-classy-addons-for-elementor'),
                'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'layout' => ['layout-21','layout-22','layout-23','layout-24','layout-25','layout-26'],
				],
            ]
        );
		$this->add_group_control(
			Group_Control_Background::get_type(),
			[
				'name'      => 'background21_26Opt',
				'types'     => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper.eca-ihe21-70,
				{{WRAPPER}} .eca-ihemain-wrapper.layout-21 .eca-ihehover-21-70',
			]
		);
		$this->end_controls_section();
		/*image style end*/
		/*background style start*/
		$this->start_controls_section(
            'background13_20Styling',
            [
                'label' => esc_html__('Background Image', 'essential-classy-addons-for-elementor'),
                'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'layout' => ['layout-13','layout-14','layout-15','layout-16','layout-17','layout-18','layout-19','layout-20'],
				],
            ]
        );
		$this->add_responsive_control(
            'bg13_20MinHeight',
            [
                'type' => Controls_Manager::SLIDER,
				'label' => esc_html__('Min. Height', 'essential-classy-addons-for-elementor'),
				'size_units' => [ 'px' ],				
				'range' => [
					'px' => [
						'min'	=> 1,
						'max'	=> 1000,
						'step' => 10,
					],
				],
				'render_type' => 'ui',				
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-ihebg-img-12' => 'min-height: {{SIZE}}{{unit}};',
				],
            ]
        );
		$this->add_control(
			'bg13_20Size',
			[
				'label' => esc_html__( 'Background Size', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'cover',
				'options' => [
					'auto' => esc_html__( 'Auto', 'essential-classy-addons-for-elementor' ),
					'cover' => esc_html__( 'Cover', 'essential-classy-addons-for-elementor' ),
					'contain' => esc_html__( 'Contain', 'essential-classy-addons-for-elementor' ),
				],
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-ihebg-img-12' => 'background-size: {{VALUE}};',
				],
			]
		);
		$this->add_control(
			'bg13_20Repeat',
			[
				'label' => esc_html__( 'Background Repeat', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'no-repeat',
				'options' => [
					'no-repeat' => esc_html__( 'No-repeat', 'essential-classy-addons-for-elementor' ),
					'repeat' => esc_html__( 'Repeat', 'essential-classy-addons-for-elementor' ),
					'repeat-x' => esc_html__( 'Repeat-x','essential-classy-addons-for-elementor' ),
					'repeat-y' => esc_html__( 'Repeat-y','essential-classy-addons-for-elementor' ),
				],
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-ihebg-img-12' => 'background-repeat: {{VALUE}};',
				],
			]
		);
		$this->add_control(
			'bg13_20Position',
			[
				'label' => esc_html__( 'Background Position', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'center center',
				'options' => [
					'center center' => esc_html__( 'Center Center', 'essential-classy-addons-for-elementor' ),
					'center left' => esc_html__( 'Center Left', 'essential-classy-addons-for-elementor' ),
					'center right' => esc_html__( 'Center Right', 'essential-classy-addons-for-elementor' ),
					'top center' => esc_html__( 'Top Center',  'essential-classy-addons-for-elementor' ),
					'top left' => esc_html__( 'Top Left','essential-classy-addons-for-elementor' ),
					'top right' => esc_html__( 'Top Right','essential-classy-addons-for-elementor' ),
					'bottom center' => esc_html__( 'Bottom Center', 'essential-classy-addons-for-elementor' ),
					'bottom left' => esc_html__( 'Bottom Left','essential-classy-addons-for-elementor' ),
					'bottom right' => esc_html__( 'Bottom Right','essential-classy-addons-for-elementor' ),
				],
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-ihebg-img-12' => 'background-position: {{VALUE}};',
				],
			]
		);
		$this->end_controls_section();
		/*background style end*/
		
		/*main box style start*/
		$this->start_controls_section(
            'mainWrapperStyling',
            [
                'label' => esc_html__('Main Wrapper', 'essential-classy-addons-for-elementor'),
                'tab' => Controls_Manager::TAB_STYLE,				
            ]
        );
		$this->add_responsive_control(
			'mainWrapperPadding',
			[
				'label' => esc_html__( 'Padding', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', 'em', '%' ],			
				'selectors' => [
					'{{WRAPPER}} ' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_responsive_control(
			'mainWrapperMargin',
			[
				'label' => esc_html__( 'Margin', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', 'em', '%' ],			
				'selectors' => [
					'{{WRAPPER}} ' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->start_controls_tabs( 'tabsMainWrapperStyle' );
		$this->start_controls_tab(
			'mainWrapperNormal',
			[
				'label' => esc_html__( 'Normal', 'essential-classy-addons-for-elementor' ),
			]
		);
		$this->add_group_control(
			Group_Control_Background::get_type(),
			[
				'name'      => 'mainWrapperNBg',
				'types'     => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper',
			]
		);
		$this->add_group_control(
			Group_Control_Border::get_type(),
			[
				'name' => 'mainWrapperNBorder',
				'label' => esc_html__( 'Border', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper',
			]
		);
		$this->add_responsive_control(
			'mainWrapperNBr',
			[
				'label'      => esc_html__( 'Border Radius', 'essential-classy-addons-for-elementor' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%' ],
				'selectors'  => [
					'{{WRAPPER}} .eca-ihemain-wrapper' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			[
				'name'     => 'mainWrapperNShadow',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper',
			]
		);
		$this->add_control(
			'mainWrapperNTransition',
			[
				'label' => esc_html__( 'Transition css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'all 0.3s linear', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper' => 'transition: {{VALUE}};'
				],
				'separator' => 'before',
			]
		);
		$this->add_control(
			'mainWrapperNTransform',
			[
				'label' => esc_html__( 'Transform css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'rotate(25deg) scale(1.2)', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper' => 'transform: {{VALUE}};-ms-transform: {{VALUE}};-moz-transform: {{VALUE}};-webkit-transform: {{VALUE}};'
				],
			]
		);
		$this->add_group_control(
			Group_Control_Css_Filter::get_type(),
			[
				'name' => 'mainWrapperNFilters',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper',
			]
		);
		$this->end_controls_tab();
		$this->start_controls_tab(
			'mainWrapperHover',
			[
				'label' => esc_html__( 'Hover', 'essential-classy-addons-for-elementor' ),
			]
		);
		$this->add_group_control(
			Group_Control_Background::get_type(),
			[
				'name'      => 'mainWrapperHBg',
				'types'     => [ 'classic', 'gradient' ],
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover',
			]
		);
		$this->add_group_control(
			Group_Control_Border::get_type(),
			[
				'name' => 'mainWrapperHBorder',
				'label' => esc_html__( 'Border', 'essential-classy-addons-for-elementor' ),
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover',
			]
		);
		$this->add_responsive_control(
			'mainWrapperHBr',
			[
				'label'      => esc_html__( 'Border Radius', 'essential-classy-addons-for-elementor' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%' ],
				'selectors'  => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);
		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			[
				'name'     => 'mainWrapperHShadow',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover',
			]
		);
		$this->add_control(
			'mainWrapperHTransition',
			[
				'label' => esc_html__( 'Transition css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'all 0.3s linear', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover' => 'transition: {{VALUE}};'
				],
				'separator' => 'before',
			]
		);
		$this->add_control(
			'mainWrapperHTransform',
			[
				'label' => esc_html__( 'Transform css', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,				
				'placeholder' => esc_html__( 'rotate(25deg) scale(1.2)', 'essential-classy-addons-for-elementor' ),
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper:hover' => 'transform: {{VALUE}};-ms-transform: {{VALUE}};-moz-transform: {{VALUE}};-webkit-transform: {{VALUE}};'
				],
			]
		);
		$this->add_group_control(
			Group_Control_Css_Filter::get_type(),
			[
				'name' => 'mainWrapperHFilters',
				'selector' => '{{WRAPPER}} .eca-ihemain-wrapper:hover',
			]
		);
		$this->end_controls_tab();
		$this->end_controls_tabs();
		$this->add_responsive_control(
            'mwZIndex',
            [
                'type' => Controls_Manager::SLIDER,
				'label' => esc_html__('Z-Index', 'essential-classy-addons-for-elementor'),
				'size_units' => [ 'px' ],				
				'range' => [
					'px' => [
						'min'	=> 0,
						'max'	=> 10000,
						'step' => 1,
					],
				],
				'render_type' => 'ui',				
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper' => 'z-index: {{SIZE}};',
				],
				'separator' => 'before',
            ]
        );
		$this->add_control(
			'mwOverflowSwitch', [
				'label'   => esc_html__( 'Overflow', 'essential-classy-addons-for-elementor' ),
				'type'    => Controls_Manager::SWITCHER,
				'default' => 'no',
				'label_on' => esc_html__( 'Enable', 'essential-classy-addons-for-elementor' ),
				'label_off' => esc_html__( 'Disable', 'essential-classy-addons-for-elementor' ),				
				'separator' => 'before',
			]
		);
		$this->add_control(
			'mwOverflow',
			[
				'label' => esc_html__( 'Overflow', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'hidden',
				'options' => [
					'unset'  => esc_html__( 'Unset', 'essential-classy-addons-for-elementor' ),
					'visible'  => esc_html__( 'Visible', 'essential-classy-addons-for-elementor' ),
					'hidden'  => esc_html__( 'Hidden', 'essential-classy-addons-for-elementor' ),
					'scroll'  => esc_html__( 'Scroll', 'essential-classy-addons-for-elementor' ),
					'auto'  => esc_html__( 'Auto', 'essential-classy-addons-for-elementor' ),
					'initial'  => esc_html__( 'Initial', 'essential-classy-addons-for-elementor' ),
					'inherit'  => esc_html__( 'Inherit', 'essential-classy-addons-for-elementor' ),
				],
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper' => 'overflow:{{VALUE}};',
				],
				'condition' => [
					'mwOverflowSwitch' =>  'yes',
				],
			]
		);
		$this->end_controls_section();
		/*main box style end*/
		
		/*extra styling start*/
		$this->start_controls_section(
            'extraStyling',
            [
                'label' => esc_html__('Extra', 'essential-classy-addons-for-elementor'),
                'tab' => Controls_Manager::TAB_STYLE,
				'condition' => [
					'layout' => ['layout-1','layout-2','layout-10','layout-11','layout-12','layout-13','layout-14','layout-15','layout-16','layout-17','layout-20'],
				],
            ]
        );
		$this->add_control(
			'st1InnerBorder',
			[
				'label' => esc_html__( 'Inner Border Color', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper.layout-1 .eca-iheinner-content:before, {{WRAPPER}} .eca-ihemain-wrapper.layout-1 .eca-iheinner-content:after' => 'border-color: {{VALUE}};',
				],
				'condition' => [
					'layout' => 'layout-1',
				],
			]
		);
		$this->add_control(
			'st2ContentBg',
			[
				'label' => esc_html__( 'Content Background Color', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper.layout-2 .eca-iheinner-content' => 'background: {{VALUE}};',
				],
				'condition' => [
					'layout' => 'layout-2',
				],
			]
		);
		$this->add_control(
			'st10_11Offset',
			[
				'label' => esc_html__( 'Offset', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::SLIDER,
				'size_units' => ['px'],
				'range' => [
					'px' => [
						'max' => 500,
						'min' => -500,
						'step' => 1,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper.layout-10 .eca-iheimage,
					{{WRAPPER}} .eca-ihemain-wrapper.layout-11 .eca-iheimage' => 'top: {{SIZE}}{{UNIT}};',
				],				
				'condition' => [
					'layout' => ['layout-10','layout-11'],
				],
			]
		);
		$this->add_control(
			'st12_17AfterColor',
			[
				'label' => esc_html__( 'After Effect Color', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper .eca-ihehover-12,
					{{WRAPPER}} .eca-ihemain-wrapper .eca-ihebg-img-12:after' => 'background: {{VALUE}};',
				],
				'condition' => [
					'layout' => ['layout-12','layout-13','layout-14','layout-15','layout-16','layout-17'],
				],
			]
		);
		$this->add_control(
			'st20Rotate',
			[
				'label' => esc_html__( 'Rotate', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::SLIDER,
				'size_units' => ['px'],
				'range' => [
					'px' => [
						'max' => 2000,
						'min' => -2000,
						'step' => 90,
					],
				],
				'default' => [
					'unit' => 'px',
					'size' => 1080,
				],
				'selectors' => [
					'{{WRAPPER}} .eca-ihemain-wrapper.layout-20.eca-iheafc-11.eca-ihe12-16 .eca-ihehover-12' => '-webkit-transform: scale(.5) rotate(-{{SIZE}}deg);
					-ms-transform: scale(.5) rotate(-{{SIZE}}deg);transform: scale(.5) rotate(-{{SIZE}}deg);',
					'{{WRAPPER}} .eca-ihemain-wrapper.layout-20.eca-iheafc-11.eca-ihe12-16:hover .eca-ihebg-img-12' => '-webkit-transform: scale(.5) rotate({{SIZE}}deg);
					-ms-transform: scale(.5) rotate({{SIZE}}deg);transform: scale(.5) rotate({{SIZE}}deg);',
				],				
				'condition' => [
					'layout' => 'layout-20',
				],
			]
		);
		$this->end_controls_section();
		/*extra styling end*/
		/*style end*/
	}
	
	protected function render() {
		 $settings = $this->get_settings_for_display();
		 
		 $layout= $settings['layout'];
		 $headingTitle= $settings['headingTitle'];
		 $headingTitleTag= !empty($settings['headingTitleTag']) ? $settings['headingTitleTag'] : 'h1';
		 $descriptionText= $settings['descriptionText'];
		 
		 $buttonType= $settings['buttonType'];
		 
		 $bit1=$bit2=$bit3=$bu1=$bu1_target=$bu1Nofollow=$bu2=$bu2Target=$bu2Nofollow=$bu3=$bu3Target=$bu3Nofollow='';
		 
		 if(!empty($buttonType) && $buttonType=='icon'){
			$buttonIcon1= $settings['buttonIcon1'];
			$buttonIcon2= $settings['buttonIcon2'];
			$buttonIcon3= $settings['buttonIcon3'];
			
			if(!empty($buttonIcon1)){
				ob_start();
				\Elementor\Icons_Manager::render_icon($buttonIcon1, [ 'aria-hidden' => 'true' ]);
				$bit1 = ob_get_contents();
				ob_end_clean();	
			}
			if(!empty($buttonIcon2)){
				ob_start();
				\Elementor\Icons_Manager::render_icon($buttonIcon2, [ 'aria-hidden' => 'true' ]);
				$bit2 = ob_get_contents();
				ob_end_clean();	
			}
			if(!empty($buttonIcon3)){
				ob_start();
				\Elementor\Icons_Manager::render_icon($buttonIcon3, [ 'aria-hidden' => 'true' ]);
				$bit3 = ob_get_contents();
				ob_end_clean();	
			}
		 }
		 
		 if(!empty($buttonType) && $buttonType=='text'){
			$buttonText1= $settings['buttonText1'];
			$buttonText2= $settings['buttonText2'];
			$buttonText3= $settings['buttonText3'];
			
			if(!empty($buttonText1)){
				$bit1 = $buttonText1;
			}
			if(!empty($buttonText2)){
				$bit2 = $buttonText2;
			}
			if(!empty($buttonText3)){
				$bit3 = $buttonText3;
			}
		 }
		 
		$buttonUrl1= $settings['buttonUrl1'];
		$buttonUrl2= $settings['buttonUrl2'];
		$buttonUrl3= $settings['buttonUrl3'];
		
		if(!empty($buttonUrl1)){
			$bu1 = $settings['buttonUrl1']['url'];
			$bu1_target = $settings['buttonUrl1']['is_external'] ? ' target="_blank"' : '';
			$bu1Nofollow = $settings['buttonUrl1']['nofollow'] ? ' rel="nofollow"' : '';
		}
		if(!empty($buttonUrl2)){
			$bu2 = $settings['buttonUrl2']['url'];
			$bu2Target = $settings['buttonUrl2']['is_external'] ? ' target="_blank"' : '';
			$bu2Nofollow = $settings['buttonUrl2']['nofollow'] ? ' rel="nofollow"' : '';
		}
		if(!empty($buttonUrl3)){
			$bu3 = $settings['buttonUrl3']['url'];
			$bu3Target = $settings['buttonUrl3']['is_external'] ? ' target="_blank"' : '';
			$bu3Nofollow = $settings['buttonUrl3']['nofollow'] ? ' rel="nofollow"' : '';
		}
		
		$image_src='';
		if(!empty($settings['aiheeImage']['id'])){			
			$image_id=$settings['aiheeImage']['id'];
			$image_src=wp_get_attachment_image_src($image_id, $settings['thumbnail_size']);
			$image_src=$image_src[0];
		}else{
			$image_src = ECAFE_ASSETS_PATH.'images/placeholder.png';
		}
		
		$finalHt=$finalDesc=$finalButton='';
		/*title start*/		
		if(!empty($headingTitle)){
			$finalHt ='<'.\EcafeHelper::check_and_validate_html_tag($headingTitleTag).' class="eca-iheheading-title">'.esc_html($headingTitle).'</'.\EcafeHelper::check_and_validate_html_tag($headingTitleTag).'>';
		}		
		/*title end*/
		
		/*description start*/
		if(!empty($descriptionText)){
			$finalDesc ='<div class="eca-ihedescription">'.$descriptionText.'</div>';
		}
		/*description end*/
		
		/*button start*/
		if(!empty($bit1) || !empty($bit2) || !empty($bit3)){
			$finalButton .='<div class="eca-iheicons">';
				if(!empty($bit1)){
					$finalButton .='<a href="'.esc_url($bu1).'" class="eca-iheicon eca-iheicon-first">'.$bit1.'</a>';
				}
				if(!empty($bit2)){
					$finalButton .='<a href="'.esc_url($bu2).'" class="eca-iheicon eca-iheicon-second">'.$bit2.'</a>';
				}
				if(!empty($bit3)){
					$finalButton .='<a href="'.esc_url($bu3).'" class="eca-iheicon eca-iheicon-third">'.$bit3.'</a>';
				}		
			$finalButton .='</div>';
		}						
		/*button end*/
		
		if(!empty($layout)){
			wp_enqueue_style('eca-ihecss');
			$layoutclass=$layoutextraclass='';
			if($layout=='layout-3' || $layout=='layout-4' || $layout=='layout-5' || $layout=='layout-6' || $layout=='layout-7' || $layout=='layout-8' || $layout=='layout-9' || $layout=='layout-10' || $layout=='layout-11'){
				$layoutclass=" eca-ihe3-11";
			}
			
			if($layout=='layout-12' || $layout=='layout-13' || $layout=='layout-14' || $layout=='layout-15' || $layout=='layout-16' || $layout=='layout-17' || $layout=='layout-18' || $layout=='layout-19' || $layout=='layout-20'){
				$layoutclass=" eca-iheafc-11";
				$layoutextraclass=" eca-ihe12-16";
			}
			
			if($layout=='layout-21' || $layout=='layout-22' || $layout=='layout-23' || $layout=='layout-24' || $layout=='layout-25' || $layout=='layout-26' || $layout=='layout-27' || $layout=='layout-28' || $layout=='layout-29' || $layout=='layout-30' || $layout=='layout-31' || $layout=='layout-32' || $layout=='layout-33' || $layout=='layout-34' || $layout=='layout-35' || $layout=='layout-36' || $layout=='layout-37' || $layout=='layout-38' || $layout=='layout-39' || $layout=='layout-40' || $layout=='layout-41' || $layout=='layout-42' || $layout=='layout-43' || $layout=='layout-44' || $layout=='layout-45' || $layout=='layout-46' || $layout=='layout-47' || $layout=='layout-48' || $layout=='layout-49' || $layout=='layout-50' || $layout=='layout-51' || $layout=='layout-52' || $layout=='layout-53' || $layout=='layout-54' || $layout=='layout-55' || $layout=='layout-56' || $layout=='layout-57' || $layout=='layout-58' || $layout=='layout-59' || $layout=='layout-60' || $layout=='layout-61' || $layout=='layout-62' || $layout=='layout-63' || $layout=='layout-64' || $layout=='layout-65' || $layout=='layout-66' || $layout=='layout-67' || $layout=='layout-68' || $layout=='layout-69' || $layout=='layout-70'){
				$layoutclass=" eca-ihe21-70";
			}
			
			$output ='<div class="eca-ihemain-wrapper '.$layout.' '.$layoutclass.' '.$layoutextraclass.'">';
				if($layout=='layout-1'){
					$output .='<img src="'.$image_src.'" class="eca-iheimage">';
					$output .='<div class="eca-iheinner-content">';
						$output .=$finalHt;
						$output .=$finalDesc;
						$output .=$finalButton;
					$output .='</div>';
				}
				
				if($layout=='layout-2'){					
					$output .='<img src="'.$image_src.'" class="eca-iheimage">';
					$output .='<div class="eca-iheinner-content">';
						$output .=$finalHt;							
						$output .=$finalButton;
						$output .=$finalDesc;
					$output .='</div>';
				}
				
				if($layout=='layout-3' || $layout=='layout-4' || $layout=='layout-5' || $layout=='layout-6' || $layout=='layout-7' || $layout=='layout-9' || $layout=='layout-10' || $layout=='layout-11'){
					$output .='<img src="'.$image_src.'" class="eca-iheimage">';					
					$output .=$finalHt;
					$output .=$finalDesc;							
					$output .=$finalButton;
				}
				
				if($layout=='layout-8'){
					$output .='<div class="eca-iheinner-content">';
						$output .='<img src="'.$image_src.'" class="eca-iheimage">';
						$output .=$finalHt;
					$output .='</div>';					
					$output .=$finalDesc;							
					$output .=$finalButton;
				}
				
				if($layout=='layout-12' || $layout=='layout-13' || $layout=='layout-14' || $layout=='layout-15' || $layout=='layout-16' || $layout=='layout-17' || $layout=='layout-18' || $layout=='layout-19' || $layout=='layout-20'){
					$output .='<div class="eca-ihebg-img-12" style=" background-image:url('.$image_src.');"></div>';
					$output .='<div class="eca-ihehover-12">';
						$output .=$finalHt;
						$output .=$finalDesc;
						$output .=$finalButton;
					$output .='</div>';
				}
				
				if($layout=='layout-21' || $layout=='layout-22' || $layout=='layout-23' || $layout=='layout-24' || $layout=='layout-25' || $layout=='layout-26'){
					$output .='<img src="'.$image_src.'" class="eca-iheimage">';
					$output .='<div class="eca-ihehover-21-70">';
						$output .=$finalHt;
						$output .=$finalDesc;
						$output .=$finalButton;
					$output .='</div>';
				}
				
			$output .='</div>';
			
			echo wp_kses_normalize_entities($output);
		}
	}
}