<?php
namespace EcafeAddons\Widgets;

use Elementor\Widget_Base;
use Elementor\Controls_Manager;
use Elementor\Utils;
use Elementor\Group_Control_Typography;
use Elementor\Core\Schemes\Typography;
use Elementor\Scheme_Color;
use Elementor\Group_Control_Background;
use Elementor\Group_Control_Border;
use Elementor\Group_Control_Box_Shadow;

use EcafeAddons\EcafeElementLoad;

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

class Ecafe_Toolset_Embeddedmedia extends Widget_Base {
		
	public function get_name() {
		return 'ecafe-toolset-embedded-media';
	}

    public function get_title() {
        return esc_html__('Toolset : Embedded Media', 'essential-classy-addons-for-elementor');
    }

    public function get_icon() {
        return 'ecafe-ele-back-icon ecafe-toolset-icon';
    }

    public function get_categories() {
        return array('ectoolset');
    }
	
	public function get_style_depends() {
		return [ 'ecafe-toolset-oembed' ];
    }
	
	public function get_keywords() {
		return [ 'toolset', 'toolset embedded','embedded','embedded media','media' ];
	}
	
    protected function register_controls() {
		
		$this->start_controls_section(
			'contentSection',
			[
				'label' => esc_html__( 'Toolset : Embedded Media', 'essential-classy-addons-for-elementor' ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);
		$this->add_control(
			'toolsetEmbedded',
			[
				'label' => esc_html__( 'Embedded Slug Name', 'essential-classy-addons-for-elementor' ),
				'type' => Controls_Manager::TEXT,
				'dynamic' => ['active' => true,],
				'default' => '',
				'placeholder' => esc_html__( 'Enter Embedded Slug Name', 'essential-classy-addons-for-elementor' ),				
			]
		);
		$this->end_controls_section();
	}
	
	 protected function render() {

        $settings = $this->get_settings_for_display();
		if( defined('WPCF_VERSION') ) {
			$toolsetEmbedded = !empty($settings['toolsetEmbedded']) ? $settings['toolsetEmbedded'] : '';
			if( (types_render_field($toolsetEmbedded)) ){
				echo '<div class="eca-toolset-embedded">';
					echo (types_render_field($toolsetEmbedded));
				echo '</div>';
			}
		}
	}
}