<?php
/*
* Plugin Name: Essential Classy Addons For Elementor
* Description: <a href="https://ecaddons.com/">Essential Classy Addons For Elementor</a> Is the Best Elementor Addons Comes With Free Elementor Widgets Including Accordion, Button, Business Hours, Changelog, Post Listing, Tabs, Image Hover Effect, Info Box, Marketing Link, Social Icons and more...
* Plugin URI: https://ecaddons.com/
* Author: KAP ASIAs
* Version: 3.0.1
* Author URI: http://kapasias.com/
* Text Domain: essential-classy-addons-for-elementor
* Elementor tested up to: 3.11
 * Elementor Pro tested up to: 3.11
*/

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

define( 'ECAFE_VERSION', '3.0.1' );

define( 'ECAFE_PATH', plugin_dir_path( __FILE__ ) );
define( 'ECAFE_BASE_NAME', plugin_basename(__FILE__) );
define( 'ECAFE_URL', plugins_url( '/', __FILE__ ) );
define( 'ECAFE_ASSETS_PATH', ECAFE_URL . 'assets/' );
define( 'ECAFE_CLASSES_URL', ECAFE_PATH . 'classes/' );
define( 'ECAFE_LIVECOPY_PATH', ECAFE_PATH . 'element/livecopy/' );

/*
 * Load core file
 */
function EcPluginsLoaded() {	
	if ( ! did_action( 'elementor/loaded' ) ) {
		add_action( 'admin_notices', 'EcElementorLoadNotice' );
		return;
	}
	load_plugin_textdomain( 'essential-classy-addons-for-elementor', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
	
	// Elementor loader
    require( ECAFE_PATH . 'classes/class-loader.php' );
}
add_action( 'plugins_loaded', 'EcPluginsLoaded' );

/* elementor load notice */
function EcElementorLoadNotice() {	
	$plugin = 'elementor/elementor.php';	
	if ( elementorActivatedNotice() ) {
		if ( ! current_user_can( 'activate_plugins' ) ) { return; }
		$activationUrl = wp_nonce_url( 'plugins.php?action=activate&amp;plugin=' . $plugin . '&amp;plugin_status=all&amp;paged=1&amp;s', 'activate-plugin_' . $plugin );
		$adminNotice = '<p>' . esc_html__( 'Essential Classy Addons For Elementor requires Elementor to be activated.', 'essential-classy-addons-for-elementor' ) . '</p>';
		$adminNotice .= '<p>' . sprintf( '<a href="%s" class="button-primary">%s</a>', $activationUrl, esc_html__( 'Activate Elementor', 'essential-classy-addons-for-elementor' ) ) . '</p>';
	} else {
		if ( ! current_user_can( 'install_plugins' ) ) { return; }
		$installUrl = wp_nonce_url( self_admin_url( 'update.php?action=install-plugin&plugin=elementor' ), 'install-plugin_elementor' );
		$adminNotice = '<p>' . esc_html__( 'Essential Classy Addons For Elementor requires Elementor to be installed and activated.', 'essential-classy-addons-for-elementor' ) . '</p>';
		$adminNotice .= '<p>' . sprintf( '<a href="%s" class="button-primary">%s</a>', $installUrl, esc_html__( 'Install Elementor', 'essential-classy-addons-for-elementor' ) ) . '</p>';
	}
	echo '<div class="notice notice-error is-dismissible">'.wp_kses_post($adminNotice).'</div>';
}

/**
* Elementor activated or not
*/
if ( ! function_exists( 'elementorActivatedNotice' ) ) {
	
	function elementorActivatedNotice() {
		$pluginPath = 'elementor/elementor.php';
		$installedPluginsCheck = get_plugins();
		
		return isset( $installedPluginsCheck[ $pluginPath ] );
	}
}